type

TVPair =
record
  ValueToken : string[10];
  ValueByte  : byte;
end;

ValuePileRec = array [1..15] of TVPair;

TokenRec = record
             FuncToken  : string[10];
             Values     : byte;
             ValuePile  : ValuePileRec;
             FieldMask  : byte;
             TokenReg   : (RegA,RegB,RegC,NoReg);
           end;

const
MaxTokens = 9;
IOAddressName = 'PortAdd';

TokenPile  : Array[1..MaxTokens] of TokenRec =

((FuncToken   :'MainMode';
  Values      : 2;
  ValuePile   : ((ValueToken :'IOMapped'   ; ValueByte:$00),
                 (ValueToken :'MemMapped'  ; ValueByte:$80),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00));
  FieldMask   : $80;
  TokenReg    : RegA),

(FuncToken    :'Compatible';
  Values      : 2;
  ValuePile   : ((ValueToken :'Yes' ; ValueByte:$00),
                 (ValueToken :'No'  ; ValueByte:$10),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00));

  FieldMask   : $10;
  TokenReg    : RegC),

(FuncToken   : IOAddressName;
  Values      : 7;
  ValuePile   : ((ValueToken :'240' ; ValueByte:$02),
                 (ValueToken :'280' ; ValueByte:$03),
                 (ValueToken :'2C0' ; ValueByte:$04),
                 (ValueToken :'300' ; ValueByte:$00),
                 (ValueToken :'320' ; ValueByte:$05),
                 (ValueToken :'340' ; ValueByte:$06),
                 (ValueToken :'360' ; ValueByte:$07),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00));

  FieldMask   : $07;
  TokenReg    : RegA),

(FuncToken   :'Interrupt';
  Values      : 9;
  ValuePile   : ((ValueToken :'None'; ValueByte:$00),
                 (ValueToken : '2'  ; ValueByte:$08),
                 (ValueToken : '3'  ; ValueByte:$10),
                 (ValueToken : '4'  ; ValueByte:$18),
                 (ValueToken : '5'  ; ValueByte:$20),
                 (ValueToken :'10'  ; ValueByte:$28),
                 (ValueToken :'11'  ; ValueByte:$30),
                 (ValueToken :'12'  ; ValueByte:$38),
                 (ValueToken :'9'   ; ValueByte:$08),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00));

  FieldMask   : $38;
  TokenReg    : RegA),

(FuncToken    :'PROMLoc';
  Values      : 15;
  ValuePile   : ((ValueToken :'None'      ; ValueByte:$00),
                 (ValueToken :'C000-16K'  ; ValueByte:$02),
                 (ValueToken :'C400-16K'  ; ValueByte:$03),
                 (ValueToken :'C800-16K'  ; ValueByte:$04),
                 (ValueToken :'CC00-16K'  ; ValueByte:$05),
                 (ValueToken :'D000-16K'  ; ValueByte:$06),
                 (ValueToken :'D400-16K'  ; ValueByte:$07),
                 (ValueToken :'D800-16K'  ; ValueByte:$08),
                 (ValueToken :'DC00-16K'  ; ValueByte:$09),
                 (ValueToken :'C000-32K'  ; ValueByte:$0A),
                 (ValueToken :'C800-32K'  ; ValueByte:$0B),
                 (ValueToken :'D000-32K'  ; ValueByte:$0C),
                 (ValueToken :'D800-32K'  ; ValueByte:$0D),
                 (ValueToken :'C000-64K'  ; ValueByte:$0E),
                 (ValueToken :'D000-64K'  ; ValueByte:$0F));

  FieldMask   : $0F;
  TokenReg    : RegC),

(FuncToken    :'CableType';
  Values      : 4;
  ValuePile   : ((ValueToken : 'Twisted'    ; ValueByte:$00),
                 (ValueToken : 'Thin'       ; ValueByte:$01),
                 (ValueToken : 'Thick'      ; ValueByte:$02),
                 (ValueToken : 'TwistedLow' ; ValueByte:$03),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00));

  FieldMask   : $03;
  TokenReg    : RegB),

(FuncToken   :'FastRead';
  Values      : 2;
  ValuePile   : ((ValueToken :'Yes' ; ValueByte:$40),
                 (ValueToken :'No'  ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00));

  FieldMask   : $40;
  TokenReg    : RegA),

(FuncToken    :'FastIO16';
  Values      : 2;
  ValuePile   : ((ValueToken :'Yes' ; ValueByte:$08),
                 (ValueToken :'No'  ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00));

  FieldMask   : $08;
  TokenReg    : RegB),

(FuncToken    :'FastChRdy';
  Values      : 2;
  ValuePile   : ((ValueToken :'Yes' ; ValueByte:$10),
                 (ValueToken :'No'  ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00),
                 (ValueToken :''    ; ValueByte:$00));

  FieldMask   : $10;
  TokenReg    : RegB));


RegAOffset : word = $0A;
RegBOffset : word = $0B;
ComRegOffset : word = $00;
MemMapRegOffset = $10;
PageRegMask : byte = $3F;

{ config register B stuff }

RegBEELoad   = $80;
GdLinkMask : byte = $FB;
{ config register C stuff }


RegCIntDecode     = $20;
RegCCLockSel      = $40;
RegCSoftEnable    = $80;

DefaultRegA = $00;
DefaultRegB = $00;
DefaultRegC = $00 or RegCIntDecode;
